typedef unsigned char byte;
typedef unsigned short int word;
typedef unsigned long int dword;

struct RIFF
{
  byte riffheader[4];
  dword WAVElen;
  struct
  {
    byte fmtheader[8];
    dword fmtlen;
    struct
    {
      word FormatTag;
      word Channels;
      dword SamplesPerSec;
      dword AvgBytesPerSec;
      word BlockAlign;
      word BitsPerSample;       /* format specific for PCM */
    }
    fmt;
    struct
    {
      byte dataheader[4];
      dword datalen;
      /* PCM data follows... */
    }
    data;
  }
  WAVE;
};

short int GetLSBFirst16Bits(int Value);
int GetLSBFirst32Bits (int Value);
int EndianMachine(void);
int Get_WAV_Header(FILE *f,struct RIFF *w,unsigned char **RollBackBuffer,int *RollBackSize);
int WAV_ReadFromStreamToRollBackBuffer(FILE *f, int bytes,unsigned char **RollBackBuffer,int *RollBackSize,int *RollBackMax);
